package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:Aitken拖延问卷
 * @date 2021/7/20 15:55
 */
public class PHCSSScale extends BaseScale{

    public PHCSSScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {

        // 自定义路径使用
        /*ScaleUtil.getScaleDll("PHCSSScale.dll");
        System.out.println("JSONArray:"+jsonArray);
        System.out.println("resultJson:"+resultJson);
        XScale xScale = new XScale(jsonArray,resultJson);
        String result = xScale.PHCSSScale(jsonArray.toString(), resultJson.toString());
        //System.out.println("dllresult:"+result);
        //解决排序问题
        LinkedHashMap<String, Object> jsonMap = JSON.parseObject(result,LinkedHashMap.class, Feature.OrderedField);
        JSONObject jsonObject = new JSONObject(true);
        jsonObject.putAll(jsonMap);
        System.out.println("jsonObject:"+jsonObject);
        return jsonObject;*/

        //得分
        int score = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (jsonObject1.getString("scoreDirection").equals("1")) {
                if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("基本不符合")) {
                    score += 2;
                } else if (jsonObject1.getString("checkItems").equals("不确定")) {
                    score += 3;
                } else if (jsonObject1.getString("checkItems").equals("基本符合")) {
                    score += 4;
                } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                    score += 5;
                }
            } else {
                if (jsonObject1.getString("checkItems").equals("完全不符合")) {
                    score += 5;
                } else if (jsonObject1.getString("checkItems").equals("基本不符合")) {
                    score += 4;
                } else if (jsonObject1.getString("checkItems").equals("不确定")) {
                    score += 3;
                } else if (jsonObject1.getString("checkItems").equals("基本符合")) {
                    score += 2;
                } else if (jsonObject1.getString("checkItems").equals("完全符合")) {
                    score += 1;
                }
            }
        }

        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_API);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
